local LibStub = LibStub
local Damnation = LibStub("AceAddon-3.0"):NewAddon("Damnation", "AceConsole-3.0")
_G.Damnation = Damnation

local GBoS = "Greater Blessing of Salvation"
local BoS = "Blessing of Salvation"
if GetLocale() ~= "enUS" then
	-- Replace this code when 2.4 hits
	LoadAddOn("LibBabble-Spell-3.0")
	local BS = LibStub("LibBabble-Spell-3.0", true)
	if BS then
		BS = BS:GetLookupTable()
		GBoS = BS[GBoS]
		BoS = BS[BoS]
		Damnation.GBoS = GBoS
		Damnation.BoS = BoS
		Damnation.RF = BS["Righteous Fury"]
	end
end

local class = select(2, UnitClass("player"))
-- For testing
--local class = "DRUID"
Damnation.class = class

local f = CreateFrame("Frame")
Damnation.f = f

function Damnation:OnInitialize()
	self:RegisterChatCommand("damn", function(msg)
		if msg == "" then
			if class == "DRUID" or class == "PALADIN" or class == "WARRIOR" then
				self:Print("Use /damn [on|auto|off] to change modes.")
			else
				self:Print("Use /damn [on|off] to change modes.")
			end
			return
		end
		msg = msg:lower()
		if msg == "on" or msg == "auto" or msg == "off" then
			return self:SetMode(msg, true)
		end
		self:Print(format("Unknown command: \"%s\"", msg))
	end)
end

function Damnation:OnEnable()
	f:SetScript("OnEvent", Damnation.OnEvent)
	local savedMode = DamnationDBPC
	if savedMode and type(savedMode) == "string" and (savedMode == "on" or savedMode == "auto" or savedMode == "off") then
		self:SetMode(savedMode)
	else
		self:Print("First time startup of Damnation!")
		self:SetMode("auto", true)
		if class == "DRUID" or class == "PALADIN" or class == "WARRIOR" then
			self:Print("Use /damn [on|auto|off] to change modes.")
		else
			self:Print("Use /damn [on|off] to change modes.")
		end
	end
end

function Damnation:OnDisable()
	f:SetScript("OnEvent", nil)
end

function Damnation:OnEvent(event, ...)
	if mode == "on" then
		Damnation:DamnOn(...)
	elseif event == "UPDATE_SHAPESHIFT_FORM" then
		Damnation:AutoDamn()
	else
		Damnation:AutoMode(...)
	end
end

function Damnation:SetMode(mode, verbose)
	if mode == "on" or mode == "auto" or mode == "off" then
		DamnationDBPC = mode
		Damnation.mode = mode
	else
		return
	end
	f:UnregisterAllEvents()
	f:SetScript("OnEvent", nil)
	if mode == "on" then
		f:SetScript("OnEvent", Damnation.OnEvent)
		f:RegisterEvent("UNIT_AURA")
		if verbose then self:Print("Mode is set to \"|cff00ff00on|r\". Will remove BoS as soon as it's gained.") end
		self:DamnOn("player")
	elseif mode == "auto" then
		self:SetAutoMode(verbose)
	elseif mode == "off" then
		if verbose then self:Print("Mode is set to \"|cffff0000off|r\". Won't touch your BoS.") end
	end
end

function Damnation:DamnOn(unit)
	if unit ~= "player" then return end
	f:SetScript("OnUpdate", Damnation.Damn)
end

function Damnation:Damn()
	f:SetScript("OnUpdate", nil)
	local name = GetPlayerBuffName(GBoS) or GetPlayerBuffName(BoS)
	if name then
		CancelPlayerBuff(name)
	end
end
